/**
**************************************************************************
* @file tester_func.h
* @brief Заголовочный файл для функций МЗКТ.
**************************************************************************
@details

*************************************************************************/

	
#ifndef _TESTER_INTERFACE_FUNC_H_
#define _TESTER_INTERFACE_FUNC_H_

#include "mylibs_include.h"
#include "rs_message.h"

typedef enum
{
  LED_IS_OFF = 0,
  LED_IS_ON = 1,
  LED_IS_BLINKING = 2,
}TESTER_LEDStateTypeDef;

typedef struct
{
  TESTER_LEDStateTypeDef state;
  
  GPIO_TypeDef  *LED_Port;
  uint32_t      LED_Pin;
  
  uint32_t      tickprev;
  uint32_t      period;
}TESTER_LEDTypeDef;


typedef struct
{
  TESTER_LEDTypeDef LED1;
}TESTER_LEDsTypeDef;


typedef struct
{
  GPIO_TypeDef  *Sw_Port;
  uint32_t      Sw_Pin;
  
  uint32_t      Sw_PrevState;
  uint32_t      Sw_FilterDelay;
  uint32_t      tickprev;
}TESTER_SwitchStartTypeDef;


/* Инициализация структур интерфейса */
void TESTER_InterfaceInit(TESTER_SwitchStartTypeDef *swstart, TESTER_LEDsTypeDef *leds);


/* Включить индикацию таймаута старта при активации теста */
void TESTER_LED_TimeoutForStartTest(TESTER_LEDTypeDef *led);
/* Включить индикацию прямого подключения диода */
void TESTER_LED_TestingDiodeForward(TESTER_LEDTypeDef *led);
/* Включить индикацию обратного подключения диода */
void TESTER_LED_TestingDiodeReverse(TESTER_LEDTypeDef *led);
/* Выключить индикацию активного теста диодов */
void TESTER_LED_WaitForAction(TESTER_LEDTypeDef *led);

/* Считать состоянии кнопки запуска */
uint8_t TESTER_ReadSwichStart(TESTER_SwitchStartTypeDef *swstart);
/* Включить светодиод */
void TESTER_LED_On(TESTER_LEDTypeDef *led);
/* Выключить светодиод */
void TESTER_LED_Off(TESTER_LEDTypeDef *led);
/* Активировать моргание светодиодом */
void TESTER_LED_Blink_Start(TESTER_LEDTypeDef *led);
/* Моргание светодиодом */
void TESTER_LEDBlink_Handle(TESTER_LEDTypeDef *led);
#endif //_TESTER_INTERFACE_FUNC_H_

